/*
 * This file is part of the AdvanceVBE project
 *
 * Copyright (C) 1999-2000 Andrea Mazzoleni
 *
 * The contents of this file are free for non-commercial use.
 * Any commercial use is forbidden.
 */

#ifndef __TSR_H
#define __TSR_H)

#include "types.h"

/* RUThere code for int2f */
#define RUT_ACK1 0xAD17
#define RUT_ACK2 0x17BE

// Chiamata all'attivazione del tsr, prima di installare gli int
// return:
//   ==0 error, don't install
//   !=0 ok
uint16 _pascal tsr_init_0(void);

// Chiamata all'attivazione del tsr, dopo aver installato gli int
// return:
//   ==0 error, don't install (call tsr_done_1())
//   !=0 ok
uint16 _pascal tsr_init_1(void);

// Chiamata alla distruzione del tsr, prima di disinstallare gli int
void _pascal tsr_done_0(void);

// Chiamata alla distruzione del tsr, dopo aver disinstallato gli int
void _pascal tsr_done_1(void);

#endif